﻿

RT_Button = {
	QuickLooter = { "disenchant", "bank" },
	addItemInfo = { func = nil, value = { }, },
	funcMenuOnClick	= function( frame ) RT_Button:Menu_OnClick(frame) end,
};


function RT_Button:AddMenuItem( level, onClick, type1, what, title, text, value, checked, hasArrow )
	if onClick == nil then onClick = 1 end; 
	if type(onClick)=="boolean" then onClick = (onClick == true) and 1 or nil end
	local e = type(onClick)
	value = (type(value)=="table") and value or { value = value };	
	local info = self.addItemInfo;
	if info.value then
		for i,v in pairs(info.value) do
			if not value[i] then value[i] = v end
		end
	end
	
	info.text = title .. (text and (" ("..text..")") or "");
	info.func = (e == "function") and onClick or (onClick and self.funcMenuOnClick);
	info.checked = checked and 1 or nil;
	info.hasArrow = hasArrow and 1 or nil;
	info.keepShownOnClick = (hasArrow and e ~= "string") and 1 or nil;
   	value.type = (type1) and type1 or value.type;
   	value.what = (what) and what or value.what
   	value.title = title
   	value.frameName = (e == "string") and onClick or nil

	info.value, value = value, info.value;
	UIDropDownMenu_AddButton(info, level);
	info.value = value;
end

function RT_Button:GetPlayerGroups( raidid )
    local raid = KARaidTrackerDB.Log[raidid];
	if not raid then return { }; end 
	-- make list without duplicates: indexes
	local indexes = { };
	local groups = { };
	local found = nil;
	
	for k, v in pairs(raid.Join) do
		if v.player then
			found = false;
			for k2, v2 in pairs(indexes) do
				if v2 == v.player then
					found = true;
					break;
				end
			end
			if not found then
				tinsert(indexes, v.player);
			end
		end
	end
	table.sort(indexes);
	-- hash the list by first letter
	local lookup = KarmaUtility._lookup.EscapeToChar;
	for k, v in pairs(indexes) do
		local group = lookup[strsub(v, 1, 2)] or v;						-- if a special char get that
		group = strupper(strsub(group, 1, 1));
		if not groups[group] then
			groups[group] = { };
		end
		tinsert(groups[group], v);
	end	
	return groups;
end



-- ************** menus **************

function RT_Button:Menu_Toggle( frame )
	local dropdown = getglobal(frame:GetName().."RightClickMenu");
	dropdown.point = "TOPLEFT";
	dropdown.relativePoint = "BOTTOMLEFT";
	ToggleDropDownMenu(1, nil, dropdown, "cursor", 0, 0);
end

function RT_Button:Menu_OnClick( frame )
	local value = frame.value
	if not value then return end
	RaidTracker:DebugTable("RT_Button:Menu_OnClick", frame:GetName(), frame.value );
	if value.frameName then
		RT_Dialog:Show(value.frameName, value.type, value.what, value.raidid, value.itemid, value.player, value.zone, value.boss);
	else
		if value.type == "rarity" then
			KARaidTrackerDB.SortOptions[ RaidTrackerFrame.type .. "filter" ] = frame:GetID();
			KA_RaidTracker_UpdateView( );
		else
			RT_Dialog:Edit_OnSave( value )
		end
		HideDropDownMenu(2)
	end
end


function RT_Button:DetailFrameItems_RarityDropdown_Update( )
	local id = KARaidTrackerDB.SortOptions[ RaidTrackerFrame.type .. "filter" ];
	UIDropDownMenu_SetSelectedID( RT_RarityDropdownFrame, id );
	RT_RarityDropdownFrameText:SetText( RT_Options.desc.rarity[ id ] );
end

function RT_DetailFrameItems_RarityDropdown_Initialize( frame, level )
	for i = 1, #RT_Options.desc.rarity do
		RT_Button:AddMenuItem( nil, nil, "rarity", nil, RT_Options.desc.rarity[i] );
	end
end
		
function RT_RaidItemTemplate_RightClickMenu_Initialize( frame, level )
	if not level then return end;
	local db, options, L = RaidTracker._db, RaidTracker._options, RaidTracker.L;
	local raidid = frame.GetParent and frame:GetParent().raidid;
	local raid = db.Log[raidid];
	if not raid then return end
	--RaidTracker:Debug("level("..level..")", raidid, this:GetID(), frame:GetName());	
	
	if level == 1 then
		RT_Button.addItemInfo.value = { raidid = raidid }
		local value = RT_Button.addItemInfo.value;
		
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "time", "raidstart",L["Edit Start"], RaidTracker:GetDisplayDate(raid.Key));
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "time", "raidend", L["Edit End"],	RaidTracker:GetDisplayDate(raid.End) or L["none"]);
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "zone", nil, L["Edit Zone"], L[raid.Zone] or L["none"], nil, db.Zones[raid.Zone], true );
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "note", "raid", L["Edit Note"], raid.note );
		RT_Button:AddMenuItem( level, "RT_ExportFrame", "export", nil, L["Show Export String"] );
		
	elseif level == 2 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end;

		if value.type == "zone" then
			for k, v in ipairs(RaidTracker_GameReleases) do
				checked = nil;
				for k1, v1 in pairs(RaidTracker_Zones) do
					if v1.rel == v and k1 == raid.Zone then checked = true; end
				end
				RT_Button:AddMenuItem( level, false, nil, nil, L[RaidTracker_Tags["REL"..v]], nil, {release = v}, checked, true )
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level );
			for k, v in pairs(db.Zones) do
				RT_Button:AddMenuItem( level, true, nil, nil, L[k], nil, k, raid.Zone == k );
			end
			RT_Button:AddMenuItem( level, true, nil, nil, L["None"], nil, nil, raid.Zone == nil);
		end
		
	elseif level == 3 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end;

		if value.type == "zone" then
			local zones = { };
			for k, v in pairs(RaidTracker_Zones) do
				if value.release == v.rel then
					tinsert( zones, v );
				end
			end
			local rt = RaidTracker;
			table.sort(zones, function(a, b) return a.pid < b.pid; end);
			for k, v in pairs(zones) do
				local title = L[v.name] .. (v.ran and (options.Color.."  ("..v.ran..")|r") or "");
				RT_Button:AddMenuItem(level, true, nil, nil, title, nil, v.name, raid.Zone == v.name)
			end
		end
	end
end

function RT_ItemsLineTemplate_RightClickMenu_Initialize( frame, level )
	if not level then return end;	
	local db, options, L = RaidTracker._db, RaidTracker._options, RaidTracker.L;
	local raidid = frame.GetParent and frame:GetParent().raidid;
	local itemid = frame.GetParent and frame:GetParent().itemid;
	local raid = db.Log[raidid];
	if not raid then return end
	local item = itemid and raid.Loot[itemid] or nil
	local itemiid = RT_ItemOptions:GetItemIid(item and item.item.id or "")
--	RaidTracker:Debug("level("..level..")", raidid, itemid);

	local checked = nil;

	if level == 1 then
		RT_Button.addItemInfo.value = { raidid=raidid, itemid=itemid }
		local value = RT_Button.addItemInfo.value;

		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "looter", nil, L["Edit Looter"], item.player, nil, nil, true );
		RT_Button:AddMenuItem( level, "RT_EditCostFrame", "itemcost", nil, L["Edit Cost"], item.costs );
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "itemcount", nil, L["Edit Count"], ((item.item.count) and item.item.count or 1) );
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "time", "itemtime", L["Edit Time"], RaidTracker:GetDisplayDate(item.time) or L["none"] );
		RT_Button:AddMenuItem( level, "RT_ItemOptionsFrame", "itemopt", nil, L["Edit Item Options"], itemiid or L["none"], { itemid=item.item.id }, db.ItemOptions[itemiid] );
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "boss", "item", L["Dropped from"], item.boss or L["none"], nil, item.boss, true );
		
	elseif level == 2 then	
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end

		if value.type == "looter" then
			for k, v in pairs(RT_Button.QuickLooter) do
				RT_Button:AddMenuItem( level, true, nil, nil, L[v], nil,  v, item.player == v );
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level );
			PlayerGroups = RT_Button:GetPlayerGroups( raidid );
			for k, v in RaidTracker:sortPairs(PlayerGroups) do
				checked = nil;
				for k2, v2 in pairs(v) do
					if item.player == v2 then checked = 1; break end
				end
				RT_Button:AddMenuItem( level, false, nil, nil, k, nil, { players=v }, checked, true );
			end
		elseif value.type == "boss" then
			RT_Button:AddMenuItem( level, true, nil, nil, L["None"], nil, nil, item.boss == nil );
			for k, v in pairs(RaidTracker_Bosses) do
				if type(v) ~= "table"  then
					RT_Button:AddMenuItem( level, true, nil, nil, L[k], nil, k, item.boss == k );
				end
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level );
			for k, v in pairs(RaidTracker_GameReleases) do
				UIDropDownMenu_AddButton( { text=L[RaidTracker_Tags["REL"..v]], disabled = 1 }, level );
				for k1, v1 in pairs(RaidTracker_Zones) do
					if v1.rel == v and RaidTracker_Bosses[k1] then 
						checked = nil
						if item.boss then
							for k2, v2 in pairs(RaidTracker_Bosses[k1]) do
								if item.boss == v2 then checked = 1; break; end
							end
						end
						RT_Button:AddMenuItem( level, false, nil, nil, L[k1], nil,  k1, checked, true );
					end
				end
			end
		end

	elseif level == 3 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end

		if value.type == "looter" then
			for k, v in pairs(value.players) do
				RT_Button:AddMenuItem( level, true, nil, nil, v, nil, v, item.player == v );
			end
		elseif value.type == "boss" then
			for k, v in pairs(RaidTracker_Bosses[value.value]) do
				if type(v) ~= "table" then
					RT_Button:AddMenuItem( level, true, nil, nil, L[v], nil,  v, item.boss == v );
				else
					for k2, v2 in pairs(v) do
						RT_Button:AddMenuItem( level, true, nil, nil, L[k], L[v2],  v2, item.boss == v2 );
					end;
				end
			end
		end
	end	
	
end


-- Next Boss selection handling
function RT_EditBossFrame_Menu_Initialize( frame, level )
	if not level then return end;
	local db, options, L = RaidTracker._db, RaidTracker._options, RaidTracker.L;
	local raidid = options.CurrentRaid;
	local raid = db.Log[raidid];
	if not raid then return end
--	RaidTracker:Debug("level("..level..")", raidid, this:GetID(), frame:GetName());	

	local i = 0;
	local ii = 0;

	i = KA_RaidTracker_Boss_Add_Button( db.Bosses["DEFAULTBOSS"], i );
	ii = ii + 1;
	
	-- no zone, just add bosses from bosses list
	if raid.Zone == nil then
		for k,v in pairs(RaidTracker_Bosses) do
			if v == 1 then
				ii = ii + 1;
				for k2,v2 in pairs(RaidTracker_BossUnitTriggers) do			-- ther are none marked with 1 so this will never happen.. was supposed to be world boss?
					if v2 == v then
						i = KA_RaidTracker_Boss_Add_Button(k2,i);
					end
				end
			end
		end
	else
		for k,v in pairs(RaidTracker_Bosses[raid.Zone] or { }) do
			local found;
			for k2,v2 in pairs(raid.Events) do
				if v2.boss == v then found = true; break end
			end
			if not found then
				if type(v) == "string" then
					ii = ii + 1;
					for k2,v2 in pairs(RaidTracker_BossUnitTriggers) do
						if v == v2 then
							i = KA_RaidTracker_Boss_Add_Button(k2,i);
						end;
					end;
				elseif type(v) == "table" then
					for k2,v2 in pairs(v) do
						ii = ii + 1;
						for k3,v3 in pairs(RaidTracker_BossUnitTriggers) do
							if v3 == v2 then
								i = KA_RaidTracker_Boss_Add_Button(k.." - "..k3,i);
							end
						end
					end
				end;
			end;
		end
	end;
	if ii == 2 then
		UIDropDownMenu_SetSelectedID(RT_EditBossFrameMenu, ii);
	end
	
end

function KA_RaidTracker_Boss_Add_Button(k,i)
	local info = {
		text = k;
		func = KA_RaidTracker_Boss_Update;
	};
	UIDropDownMenu_AddButton(info);
	if i == cur_class_id then
		UIDropDownMenu_SetSelectedID(RT_EditBossFrameMenu, i+1);
		UIDropDownMenu_SetText(info.text, RT_EditBossFrameMenu);
	end
	return i
end

function KA_RaidTracker_Boss_Update( frame )
	id = this:GetID();
	UIDropDownMenu_SetSelectedID( RT_EditBossFrameMenu, id );
end


function RT_Button:OnClick( frame, type, what )
	local parent = frame:GetParent()
	local name

	if type == "delete" then
		name = "RT_ConfirmDeleteFrame"
	elseif type == "note" then 
		name = "RT_EditNoteFrame"
	end

	RT_Dialog:Show(name, type, what, parent.raidid, parent.itemid, parent.playerid ); 
end

function RT_Button:OnEnter( frame, type, what )
	local parent = frame:GetParent()
	local title, text = "Title" 

	if type == "delete" then
		title = "Click to delete"
        getglobal(parent:GetName() .. "DeleteText"):SetTextColor(0.8, 0.5, 0);
	elseif type == "note" then 
		title = "Click to edit note"
		local raid = KARaidTrackerDB.Log[parent.raidid];
		if		what == "item"		then item = raid.Loot[parent.itemid]
		elseif	what == "player"	then item = raid.Players[parent.playerid] end
		text = item and item.note
	end

    GameTooltip:SetOwner(frame, "ANCHOR_RIGHT");
    GameTooltip:ClearLines();
	GameTooltip:AddLine(title);
	if text then GameTooltip:AddLine(text, 0.9, 0.9, 0.9, 1) end
    GameTooltip:Show();
end



function RT_Button:ShowLinkTooptip( frame, button, loot, item )
	if not frame then return end
	item = item or (loot and loot.item)
	if not item then return end
	
	if button == "LeftButton" then
        if IsControlKeyDown() then
			DressUpItemLink("item:"..item.id);
        elseif IsShiftKeyDown() then        
			local sLink = "|c"..item.c.."|Hitem:"..item.id.."|h["..item.name.."]|h|r";
			if type(WIM_API_InsertText)=="function" then
				WIM_API_InsertText(sLink);
			end
			if ChatFrameEditBox:IsVisible() then
				ChatFrameEditBox:Insert(sLink);
			end
        end
        return
    end

	local L = RaidTracker.L;
	local r, g, b = RaidTracker:ColorToRGB(RaidTracker._options.Color);
	local sName,sLink,_,_,_,sClass,sSubClass = GetItemInfo("item:" .. item.id);

	GameTooltip:SetOwner(frame, "ANCHOR_BOTTOMRIGHT");
	if sName or button=="RightButton" then
		GameTooltip:SetHyperlink("item:" .. item.id);
	else
		GameTooltip:AddLine(item.name, RaidTracker:ColorToRGB(item.c));
		GameTooltip:AddLine("This item is not in your cache, right-click to try to get the item.", 1, 1, 1, 1);
		GameTooltip:AddLine("Warning: This may result in a disconnect!", 1, 0, 0);
	end
							GameTooltip:AddLine(" ");
	if loot then
		if loot.time then	GameTooltip:AddLine(RaidTracker:GetDisplayDate(loot.time), r, g, b); end
		if loot.zone then	GameTooltip:AddLine(L[loot.zone], r, g, b)	end
		if loot.boss then	GameTooltip:AddLine(L[loot.boss], r, g, b)	end
		if loot.costs then	GameTooltip:AddLine(loot.costs, r, g, b) end
	end
	if item.class or sClass then	
							GameTooltip:AddLine(L[item.class or sClass], r, g, b) end
	if (item.subclass or sSubClass) and (item.class or sClass) ~= (item.subclass or sSubClass) then
							GameTooltip:AddLine(L[item.subclass or sSubClass], r, g, b) end

	GameTooltip:Show();
end

